## org.springframework.orm.jpa.support
Class SharedEntityManagerBean

    java.lang.Object
      org.springframework.orm.jpa.EntityManagerFactoryAccessor
          org.springframework.orm.jpa.support.SharedEntityManagerBean

All Implemented Interfaces:
  FactoryBean<javax.persistence.EntityManager>, InitializingBean

    public class SharedEntityManagerBean

extends EntityManagerFactoryAccessor
implements FactoryBean<javax.persistence.EntityManager>, InitializingBean

`FactoryBean` that exposes a shared JPA `EntityManager` reference for a given EntityManagerFactory. Typically used for an EntityManagerFactory created by `LocalContainerEntityManagerFactoryBean`, as direct alternative to a JNDI lookup for a Java EE 5 server's EntityManager reference.

The shared EntityManager will behave just like an EntityManager fetched from an application server's JNDI environment, as defined by the JPA specification. It will delegate all calls to the current transactional EntityManager, if any; otherwise, it will fall back to a newly created EntityManager per operation.

Can be passed to DAOs that expect a shared EntityManager reference rather than an EntityManagerFactory. Note that Spring's `JpaTransactionManager` always needs an EntityManagerFactory in order to create new transactional EntityManager instances.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  `EntityManagerFactoryAccessor.setEntityManagerFactory(javax.persistence.EntityManagerFactory)`, `setEntityManagerInterface(java.lang.Class<? extends javax.persistence.EntityManager>)`, `LocalEntityManagerFactoryBean`, `JpaTransactionManager`

Field Summary

Fields inherited from class org.springframework.orm.jpa.EntityManagerFactoryAccessor
`logger`

Constructor Summary
`SharedEntityManagerBean()`

Method Summary
`void` `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`javax.persistence.EntityManager` `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`Class<? extends javax.persistence.EntityManager>` `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` `setEntityManagerInterface(Class<? extends javax.persistence.EntityManager> entityManagerInterface)` Specify the EntityManager interface to expose.

Methods inherited from class org.springframework.orm.jpa.EntityManagerFactoryAccessor
`createEntityManager, getEntityManagerFactory, getJpaPropertyMap, getTransactionalEntityManager, setEntityManagerFactory, setJpaProperties, setJpaPropertyMap`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SharedEntityManagerBean

    public SharedEntityManagerBean()

Method Detail

### setEntityManagerInterface

    public void setEntityManagerInterface(Class<? extends javax.persistence.EntityManager> entityManagerInterface)

  Specify the EntityManager interface to expose.

  Default is the EntityManager interface as defined by the EntityManagerFactoryInfo, if available. Else, the standard `javax.persistence.EntityManager` interface will be used.

  See Also:
    `EntityManagerFactoryInfo.getEntityManagerInterface()`, `EntityManager`

### afterPropertiesSet

    public final void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getObject

    public javax.persistence.EntityManager getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<javax.persistence.EntityManager>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public Class<? extends javax.persistence.EntityManager> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<javax.persistence.EntityManager>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<javax.persistence.EntityManager>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`